<?php
/*
This file generates an XML file in the AVM standard.  

Presently, there is no validation based on the xml schemas, but as soon as a namespace is created for AVM, this script will incorporate validation.

*/

function generate_ns_tags ( $xmlns ) {
    include ('namespaces.php');
    
    if ( $xmlns == $rdf_ns )
        $tag = "rdf";
    
    if ( $xmlns == $iptc_ns )
        $tag = "Iptc4xmpCore";
    
    if ( $xmlns == $photoshop_ns )
        $tag = "photoshop";
    
    if ( $xmlns == $dc_ns )
        $tag = "dc";
    
    if ( $xmlns == $avm_ns )
        $tag = "avm";
    
    if ( $xmlns == $xaprights_ns )
        $tag = "xapRights";
        
    $tags = array($tag, "<" . $tag . ":", "</" . $tag . ":");
    return $tags;
}

function write_tabs ( $level, $handle ) {
    while ( $level > 0 ) {
        fwrite ( $handle, "\t" );
        --$level;
    }
}

function write_namespace ( $xmlns, $handle ) {
    $tags = generate_ns_tags ( $xmlns );
    $namespace = "xmlns:" . $tags[0] . "=\"" . $xmlns . "\"";
    fwrite ( $handle, $namespace );
} 

function write_header ( $handle ) {
    include ( 'variables.php' );
    $level = 0;
    
    fwrite ( $handle, $packetOpen . "\n");
    
    ++$level;
    write_tabs ( $level, $handle );
    
    fwrite ( $handle, $xmpMetaOpen . "\n" );
    
    ++$level;
    write_tabs ( $level, $handle );
    
    fwrite ( $handle, $rdfNamespaceOpen . "\n" );
}

function write_closer ( $handle ) {
    include ( 'variables.php' );
    $level = 2;
    
    write_tabs ( $level, $handle );
    fwrite ( $handle, $rdfNamespaceClose . "\n" );
    
    --$level;
    write_tabs ( $level, $handle );
    
    fwrite ( $handle, $xmpMetaClose . "\n" );
    
    --$level;
    write_tabs ( $level, $handle );
    
    fwrite ( $handle, $packetClose . "\n");
}

function write_data ( $xmlData, $xmlns, $handle ) {

    include ( 'variables.php' );
    include ( 'namespaces.php' );
    $level = 3;
    
    $tags = generate_ns_tags ( $xmlns );
    
    write_tabs ( $level, $handle );
    fwrite ( $handle, $rdfDescriptionOpen . " xmlns:" . $tags[0] . "=\"" . $xmlns . "\" " . $rdfAbout . "\n" );
    
    if ( $xmlns == $iptc_ns ) {
        ++$level;
        write_tabs ( $level, $handle );
        fwrite ( $handle, $iptcCreatorContactOpen . "\n" );
    }
    
    if ( $xmlns == $xaprights_ns ) {
        ++$level;
        write_tabs ( $level, $handle );
        fwrite ( $handle, $xapRightsOpen . "\n" );
        
        ++$level;
        write_tabs ( $level, $handle );
        fwrite ( $handle, $rdfAltOpen . "\n" );
    }

    foreach ( $xmlData as $key => $data ) {
        if ( !empty($data) ) {
        
            if ( is_array ( $data ) ) {
                if ( !empty($data) ) {
                    ++$level;
                    write_tabs ( $level, $handle );
                    fwrite ( $handle, $tags[1] . $key . ">\n" );
        
                    ++$level;
                    write_tabs ( $level, $handle );
                    fwrite ( $handle, $rdfSeqOpen . "\n" );
        
                    foreach ( $data as $listelement ) {
                        if ( !empty($listelement) ) {
                            ++$level;
                            write_tabs ( $level, $handle );
                            fwrite ( $handle, $rdfliOpen . $listelement . $rdfliClose . "\n" );
                            --$level;
                        }
                    }
                    write_tabs ( $level, $handle );
                    fwrite ( $handle, $rdfSeqClose . "\n" );
                    --$level;
                    write_tabs ( $level, $handle );
                    fwrite ( $handle, $tags[2] . $key . ">\n" );
                    --$level;
                }
                
            } else {
                if ( $xmlns == $xaprights_ns ) {
                    ++$level;
                    write_tabs ( $level, $handle );
                    fwrite ( $handle, "<rdf:li xml:lang=\"x-default\">" . $data . "</rdf:li>" . "\n" );
                    --$level;        
                }
                else {
                    ++$level;
                    write_tabs ( $level, $handle );
                    fwrite ( $handle, $tags[1] . $key . ">" . $data . $tags[2] . $key . ">\n" );
                    --$level;
                }
            }
        }
    }
    if ( $xmlns == $iptc_ns ) {
        write_tabs ( $level, $handle );
        --$level;
        fwrite ( $handle, $iptcCreatorContactClose . "\n" );
    }
    
    if ( $xmlns == $xaprights_ns ) {
        write_tabs ( $level, $handle );
        fwrite ( $handle, $rdfAltClose . "\n" );
        
        --$level;
        write_tabs ( $level, $handle );
        fwrite ( $handle, $xapRightsClose . "\n" );
    }
    
    write_tabs ( $level, $handle );
    fwrite ( $handle, $rdfDescriptionClose . "\n" );
}
?>